using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
	public class Saitama : MonoBehaviour
    {
        public LimbBehaviour limb;
		float deltaTime = Time.deltaTime;
		readonly float Max = Mathf.Infinity;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
			limb.CirculationBehaviour.IsDisconnected = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.IsDismembered = false;
			limb.IsLethalToBreak = false;
			limb.Joint.breakForce += deltaTime * Max;
			limb.Joint.breakTorque += deltaTime * Max;
			limb.ExplodeLiquidAmount += deltaTime * Max;
			limb.Broken = false;
			limb.CirculationBehaviour.IsPump = true;
		    }
        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();
		    limb.HealBone();
			limb.CirculationBehaviour.HealBleeding();
			limb.PhysicalBehaviour.BurnProgress = 0f;
			limb.PhysicalBehaviour.ReflectsLasers = true;
			limb.IsLethalToBreak = false;
			limb.Numbness = float.NegativeInfinity;
			limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), float.PositiveInfinity);
			limb.CirculationBehaviour.ForceSetAllLiquid(float.PositiveInfinity);
			limb.ExplodeLiquidAmount = float.PositiveInfinity;
			limb.Person.ShockLevel = 0f;
			limb.Person.PainLevel = 0f;
			limb.GetComponent<LimbBehaviour>().Frozen = false;
			limb.BreakingThreshold = float.PositiveInfinity;
			limb.ImmuneToDamage = true;
			limb.CirculationBehaviour.ImmuneToDamage = true;
			limb.IsDismembered = false;
			limb.PhysicalBehaviour.Charge = 0f;
			limb.Person.AdrenalineLevel = float.PositiveInfinity;
			limb.BruiseCount = (ushort)0;
			limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
			limb.CirculationBehaviour.StabWoundCount = (ushort)0;
			limb.BloodDecal = null;
			limb.Person.BrainDamaged = false;
			limb.Person.Braindead = false;
			limb.LungsPunctured = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
			limb.PhysicalBehaviour.Deletable = true;
			limb.PhysicalBehaviour.Resizable = true;
			limb.Person.Consciousness = float.PositiveInfinity;
			limb.Person.OxygenLevel = float.PositiveInfinity;
			limb.PhysicalBehaviour.SimulateTemperature = false;
			limb.CirculationBehaviour.IsPump = true;
			limb.DoStumble = false;
			limb.BodyTemperature = 37f;
			limb.GetComponent<PhysicalBehaviour>().ChargeBurns = false;
			limb.GetComponent<PhysicalBehaviour>().ConductOverride = false;
			limb.GetComponent<PhysicalBehaviour>().ForceNoCharge = true;
			limb.GetComponent<PhysicalBehaviour>().ForceNoChargeParticles = true;
			limb.GetComponent<PhysicalBehaviour>().Properties.Conducting = false;
			limb.PhysicalBehaviour.Properties.Flammability = 0f;
			limb.PhysicalBehaviour.Properties.ShotImpact = null;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 37f;
	        }
        }

    public class Immortal : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
		    }
        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();
		    limb.HealBone();
			limb.CirculationBehaviour.HealBleeding();
			limb.PhysicalBehaviour.BurnProgress = 0f;
			limb.SkinMaterialHandler.AcidProgress = 0f;
			limb.SkinMaterialHandler.RottenProgress = 0f;
			limb.InitialHealth = float.MaxValue;
			limb.Health = float.PositiveInfinity;
			limb.RegenerationSpeed = float.PositiveInfinity;
			limb.PhysicalBehaviour.ReflectsLasers = true;
			limb.IsLethalToBreak = false;
			limb.Numbness = float.NegativeInfinity;
			limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), float.PositiveInfinity);
			limb.CirculationBehaviour.ForceSetAllLiquid(float.PositiveInfinity);
			limb.ExplodeLiquidAmount = float.PositiveInfinity;
			limb.Person.ShockLevel = 0f;
			limb.Person.PainLevel = 0f;
			limb.GetComponent<LimbBehaviour>().Frozen = false;
			limb.BreakingThreshold = float.PositiveInfinity;
			limb.ImmuneToDamage = true;
			limb.CirculationBehaviour.ImmuneToDamage = true;
			limb.IsDismembered = false;
			limb.PhysicalBehaviour.Charge = 0f;
			limb.Person.AdrenalineLevel = float.PositiveInfinity;
			limb.BruiseCount = (ushort)0;
			limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
			limb.CirculationBehaviour.StabWoundCount = (ushort)0;
			limb.BloodDecal = null;
			limb.Person.BrainDamaged = false;
			limb.Person.Braindead = false;
			limb.LungsPunctured = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
			limb.PhysicalBehaviour.Deletable = false;
			limb.PhysicalBehaviour.Resizable = true;
			limb.PhysicalBehaviour.ChargeBurns = false;
			limb.Person.Consciousness = float.PositiveInfinity;
			limb.Person.OxygenLevel = float.PositiveInfinity;
			limb.PhysicalBehaviour.SimulateTemperature = false;
			limb.CirculationBehaviour.IsPump = true;
			limb.DoStumble = false;
			limb.PhysicalBehaviour.Temperature = 37f;
			limb.PhysicalBehaviour.Properties.Flammability = 0f;
			limb.PhysicalBehaviour.Properties.ShotImpact = null;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 37f;
			Component[] components = limb.gameObject.GetComponents(typeof(Component));
	        }
        }

	public	class Undeath : MonoBehaviour
    {
		Coroutine coroutine0;
		public LimbBehaviour limb;
        public bool CanRegen = true;
        public bool CanResurect = true;
		public bool isOnFire = false;
        public float RegenSpeed = 0;
		float deltaTime = Time.deltaTime;
		readonly float Max = Mathf.Infinity;
		
		public void Awake()
        {
			limb = gameObject.GetComponent<LimbBehaviour>();
		    }
		
        public void Start()
        {
            limb = GetComponent<LimbBehaviour>();
			//limb.RegenerationSpeed += 1f;
			coroutine0 = limb.StartCoroutine(BaseHeal(limb));
			//limb.gameObject.GetComponent<PhysicalBehaviour>().Deletable = false;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
			//limb.PhysicalBehaviour.Deletable = false;
			limb.CirculationBehaviour.IsDisconnected = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.IsDismembered = false;
			limb.IsLethalToBreak = false;
			limb.Joint.breakForce += deltaTime * Max;
			limb.Joint.breakTorque += deltaTime * Max;
			limb.BreakingThreshold += deltaTime * Max;
			limb.ExplodeLiquidAmount += deltaTime * Max;
			limb.Broken = false;
			limb.CirculationBehaviour.IsPump = true;
            }
		
		public void FixedUpdate()
        {
			if (!CanRegen)
            {
                StopCoroutine(BurnDamageHeal(limb));
                StopCoroutine(BulletHoleDamageHeal(limb));
                StopCoroutine(DamagePointHeal(limb));
                StopCoroutine(RotDamageHea(limb));
                StopCoroutine(AcidDamageHeal(limb));
				CanRegen = true;
                }
			limb.CirculationBehaviour.IsPump = true;
			limb.CirculationBehaviour.IsDisconnected = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			//limb.PhysicalBehaviour.Deletable = false;
			//limb.gameObject.GetComponent<PhysicalBehaviour>().Deletable = false;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
			limb.BreakingThreshold += deltaTime * Max;
			limb.ExplodeLiquidAmount += deltaTime * Max;
			limb.IsDismembered = false;
            limb.IsLethalToBreak = false;
			limb.Joint.breakForce += deltaTime * Max;
			limb.Joint.breakTorque += deltaTime * Max;
			limb.Person.Consciousness += (deltaTime * limb.RegenerationSpeed) / 15;
			if (limb.Health < limb.InitialHealth)
            {
                limb.Health += 1f * 50 * Time.deltaTime;
                };
            }

        Coroutine coroutine1;
        Coroutine coroutine2;
        Coroutine coroutine3;
        Coroutine coroutine4;
        Coroutine coroutine5;
		

        private IEnumerator BaseHeal(LimbBehaviour limb)
        {
            if (CanResurect == true)
            {
                while (CanRegen == true)
                {
					if ((limb.Person.Consciousness < 0.8) || (limb.LungsPunctured == true))
					{
						RegenSpeed += 5;
				        }
					else if ((limb.Person.Consciousness >= 0.8) || (limb.LungsPunctured == false))
					{
						RegenSpeed += 3;
					    }
					limb.HealBone();
					if (limb.LungsPunctured == true)
					{
						//yield return new WaitForSeconds(RegenSpeed);
						limb.LungsPunctured = false;
					    }
					if ((limb.HasBrain) && (limb.Person.BrainDamaged == true))
					{
						//yield return new WaitForSeconds(RegenSpeed);
						limb.Person.BrainDamaged = false;
					    }
					if ((limb.HasBrain) && (limb.Person.Braindead == true))
					{
						//yield return new WaitForSeconds(RegenSpeed);
						limb.Person.Braindead = false;
					    }
					limb.CirculationBehaviour.HealBleeding();
                    limb.Numbness = 0f;
                    limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
					limb.CirculationBehaviour.BloodFlow += (deltaTime * limb.RegenerationSpeed) / 3;
					if (limb.CirculationBehaviour.BloodFlow > 1f)
					{
						limb.CirculationBehaviour.BloodFlow = 1f;
					    }
					if (limb.CirculationBehaviour.BloodAmount >= 1f)
					{
						limb.CirculationBehaviour.BloodAmount = 1f;
					    }
					if (limb.CirculationBehaviour.BloodAmount < 1f)
					{
						limb.CirculationBehaviour.BloodAmount += (deltaTime * limb.RegenerationSpeed) / 3;
					    }
                    limb.BruiseCount = (ushort)0;
					double num = (double) limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), Mathf.Max(0.0f, 1f - limb.CirculationBehaviour.GetAmount(limb.GetOriginalBloodType())));
                    limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                    limb.CirculationBehaviour.StabWoundCount = (ushort)0;
					limb.PhysicalBehaviour.Extinguish();
					coroutine1 = StartCoroutine(BurnDamageHeal(limb));
					coroutine2 = StartCoroutine(BulletHoleDamageHeal(limb));
					coroutine3 = StartCoroutine(DamagePointHeal(limb));
					coroutine4 = StartCoroutine(RotDamageHea(limb));
					coroutine5 = StartCoroutine(AcidDamageHeal(limb));
					CanRegen = false;
                    yield return new WaitForSeconds(RegenSpeed);
                   }
                }
		    }
			
        private IEnumerator DamagePointHeal(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.damagePoints.Length; ++index)
                limb.SkinMaterialHandler.damagePoints[index].z -= Time.deltaTime * 0.014f;
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
                }
            }

        private IEnumerator BurnDamageHeal(LimbBehaviour limb)
        {
			limb.PhysicalBehaviour.Temperature = limb.BodyTemperature;
			while (limb.PhysicalBehaviour.BurnProgress > 0.02f)
			{
				limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.008f;
				yield return new WaitForEndOfFrame();
			    }
			limb.PhysicalBehaviour.BurnProgress = 0f;
            }

        private IEnumerator AcidDamageHeal(LimbBehaviour limb)
        {
			while (limb.SkinMaterialHandler.AcidProgress > 0.02f)
			{
				limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.015f;
				yield return new WaitForEndOfFrame();
			    }
			limb.SkinMaterialHandler.AcidProgress = 0f;
            }

        private IEnumerator RotDamageHea(LimbBehaviour limb)
        {
			while (limb.SkinMaterialHandler.RottenProgress > 0.02f)
			{
				limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.015f;
				yield return new WaitForEndOfFrame();
			    }
			limb.SkinMaterialHandler.RottenProgress = 0f;
            }


        private IEnumerator BulletHoleDamageHeal(LimbBehaviour limb)
        {
			float factor = Mathf.Pow(0.5f, Time.deltaTime);
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.bulletHolePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
				for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
				{
					Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
					int num = i;
					damagePoints[num].z = damagePoints[num].z * factor;
				    }
				limb.SkinMaterialHandler.Sync();
				yield return new WaitForEndOfFrame();
                }
            }
        }
	
	public	class Regeneration : MonoBehaviour
    {
		Coroutine coroutine0;
		public LimbBehaviour limb;
        public bool CanRegen = true;
        public bool CanResurect = true;
		public bool isOnFire = false;
        public float RegenSpeed = 0;
		public float RegenPower = 50;
		float deltaTime = Time.deltaTime;
		readonly float Max = Mathf.Infinity;
		
		public void Awake()
        {
			limb = gameObject.GetComponent<LimbBehaviour>();
		    }
		
        public void Start()
        {
            limb = GetComponent<LimbBehaviour>();
			//limb.RegenerationSpeed += 1f;
			coroutine0 = limb.StartCoroutine(BaseHeal(limb));
			//limb.gameObject.GetComponent<PhysicalBehaviour>().Deletable = false;
			//limb.PhysicalBehaviour.Deletable = false;
			limb.CirculationBehaviour.IsDisconnected = false;
			limb.IsDismembered = false;
			limb.IsLethalToBreak = false;
			limb.Joint.breakForce += deltaTime * Max;
			limb.Joint.breakTorque += deltaTime * Max;
			limb.BreakingThreshold += deltaTime * Max;
			limb.ExplodeLiquidAmount += deltaTime * Max;
            }
		
		public void FixedUpdate()
        {
			if ((limb.HasBrain) && (limb.Person.Braindead == true))
		    {
				CanRegen = false;
			    }
			if (!CanRegen)
            {
                StopCoroutine(BurnDamageHeal(limb));
                StopCoroutine(BulletHoleDamageHeal(limb));
                StopCoroutine(DamagePointHeal(limb));
                StopCoroutine(RotDamageHea(limb));
                StopCoroutine(AcidDamageHeal(limb));
				CanRegen = true;
                }
			limb.CirculationBehaviour.IsPump = true;
			limb.CirculationBehaviour.IsDisconnected = false;
			//limb.PhysicalBehaviour.Deletable = false;
			//limb.gameObject.GetComponent<PhysicalBehaviour>().Deletable = false;
			limb.ExplodeLiquidAmount += deltaTime * Max;
			limb.IsDismembered = false;
			limb.Person.Consciousness += (deltaTime * limb.RegenerationSpeed) / 15;
			if (limb.Health < limb.InitialHealth)
            {
                limb.Health += (limb.InitialHealth / RegenPower) * Time.deltaTime;
                };
            }

        Coroutine coroutine1;
        Coroutine coroutine2;
        Coroutine coroutine3;
        Coroutine coroutine4;
        Coroutine coroutine5;
		

        private IEnumerator BaseHeal(LimbBehaviour limb)
        {
            if (CanResurect == true)
            {
                while (CanRegen == true)
                {
					if ((limb.Person.Consciousness < 0.8) || (limb.LungsPunctured == true))
					{
						RegenSpeed += 5;
				        }
					else if ((limb.Person.Consciousness >= 0.8) || (limb.LungsPunctured == false))
					{
						RegenSpeed += 3;
					    }
					limb.HealBone();
					if (limb.LungsPunctured == true)
					{
						//yield return new WaitForSeconds(RegenSpeed);
						limb.LungsPunctured = false;
					    }
					if ((limb.HasBrain) && (limb.Person.BrainDamaged == true))
					{
						//yield return new WaitForSeconds(RegenSpeed);
						limb.Person.BrainDamaged = false;
					    }
					limb.CirculationBehaviour.HealBleeding();
                    limb.Numbness = 0f;
                    limb.CirculationBehaviour.IsPump = limb.CirculationBehaviour.WasInitiallyPumping;
					limb.CirculationBehaviour.BloodFlow += (deltaTime * limb.RegenerationSpeed) / 3;
					if (limb.CirculationBehaviour.BloodFlow > 1f)
					{
						limb.CirculationBehaviour.BloodFlow = 1f;
					    }
					if (limb.CirculationBehaviour.BloodAmount >= 1f)
					{
						limb.CirculationBehaviour.BloodAmount = 1f;
					    }
					if (limb.CirculationBehaviour.BloodAmount < 1f)
					{
						limb.CirculationBehaviour.BloodAmount += (deltaTime * limb.RegenerationSpeed) / 3;
					    }
                    limb.BruiseCount = (ushort)0;
					double num = (double) limb.CirculationBehaviour.AddLiquid(limb.GetOriginalBloodType(), Mathf.Max(0.0f, 1f - limb.CirculationBehaviour.GetAmount(limb.GetOriginalBloodType())));
                    limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                    limb.CirculationBehaviour.StabWoundCount = (ushort)0;
					coroutine1 = StartCoroutine(BurnDamageHeal(limb));
					coroutine2 = StartCoroutine(BulletHoleDamageHeal(limb));
					coroutine3 = StartCoroutine(DamagePointHeal(limb));
					coroutine4 = StartCoroutine(RotDamageHea(limb));
					coroutine5 = StartCoroutine(AcidDamageHeal(limb));
					CanRegen = false;
                    yield return new WaitForSeconds(RegenSpeed);
                   }
                }
		    }

		private IEnumerator DamagePointHeal(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.damagePoints.Length; ++index)
                limb.SkinMaterialHandler.damagePoints[index].z -= Time.deltaTime * 0.014f;
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
                }
            }

        private IEnumerator BurnDamageHeal(LimbBehaviour limb)
        {
			limb.PhysicalBehaviour.Temperature = limb.BodyTemperature;
			while (limb.PhysicalBehaviour.BurnProgress > 0.02f)
			{
				limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.008f;
				yield return new WaitForEndOfFrame();
			    }
			limb.PhysicalBehaviour.BurnProgress = 0f;
            }

        private IEnumerator AcidDamageHeal(LimbBehaviour limb)
        {
			while (limb.SkinMaterialHandler.AcidProgress > 0.02f)
			{
				limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.015f;
				yield return new WaitForEndOfFrame();
			    }
			limb.SkinMaterialHandler.AcidProgress = 0f;
            }

        private IEnumerator RotDamageHea(LimbBehaviour limb)
        {
			while (limb.SkinMaterialHandler.RottenProgress > 0.02f)
			{
				limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.015f;
				yield return new WaitForEndOfFrame();
			    }
			limb.SkinMaterialHandler.RottenProgress = 0f;
            }


        private IEnumerator BulletHoleDamageHeal(LimbBehaviour limb)
        {
			float factor = Mathf.Pow(0.5f, Time.deltaTime);
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.bulletHolePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
				for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
				{
					Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
					int num = i;
					damagePoints[num].z = damagePoints[num].z * factor;
				    }
				limb.SkinMaterialHandler.Sync();
				yield return new WaitForEndOfFrame();
                }
            }
        }

	public class BulletProff : MonoBehaviour
    {
		public LimbBehaviour limb;
		float TrueStrength = 0;
        float TrueHealth = 0;
        public void Update()
        {
			limb = GetComponent<LimbBehaviour>();
			limb.PhysicalBehaviour.BulletPenetration = false;
			limb.PhysicalBehaviour.Properties.ShotImpact = null;
			limb.PhysicalBehaviour.Properties.BulletSpeedAbsorptionPower = 0f;

			if (GetComponent<LimbBehaviour>().Health > 0f)
			{
                if (GetComponent<LimbBehaviour>().CirculationBehaviour.GunshotWoundCount > 0)
                {
                    GetComponent<LimbBehaviour>().CirculationBehaviour.GunshotWoundCount = 0;
                    GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    GetComponent<LimbBehaviour>().Health = TrueHealth;
                    GetComponent<LimbBehaviour>().Numbness = 0;
                    GetComponent<LimbBehaviour>().BaseStrength = TrueStrength;
                    }
                if (GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingPointCount > 0)
                {
                    GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    GetComponent<LimbBehaviour>().Health = TrueHealth;
                    GetComponent<LimbBehaviour>().Numbness = 0;
                    GetComponent<LimbBehaviour>().BaseStrength = TrueStrength;
                    }
				if (GetComponent<LimbBehaviour>().CirculationBehaviour.StabWoundCount > 0)
                {
                    GetComponent<LimbBehaviour>().CirculationBehaviour.HealBleeding();
                    GetComponent<LimbBehaviour>().Health = TrueHealth;
                    GetComponent<LimbBehaviour>().Numbness = 0;
                    GetComponent<LimbBehaviour>().BaseStrength = TrueStrength;
                    }
					
                TrueHealth = GetComponent<LimbBehaviour>().Health;
				TrueStrength = GetComponent<LimbBehaviour>().BaseStrength;
			    }
            }
        }

	public class FireProff : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
		    }
        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();

			limb.PhysicalBehaviour.BurnProgress = 0f;
			limb.PhysicalBehaviour.ChargeBurns = false;
			limb.PhysicalBehaviour.SimulateTemperature = false;
			limb.BodyTemperature = 37f;
			limb.PhysicalBehaviour.Properties.Flammability = 0f;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 37f;
	        }
        }

	public class ElectroProff : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();

			limb.GetComponent<PhysicalBehaviour>().ChargeBurns = false;
			limb.GetComponent<PhysicalBehaviour>().ConductOverride = false;
			limb.GetComponent<PhysicalBehaviour>().ForceNoCharge = true;
			limb.GetComponent<PhysicalBehaviour>().ForceNoChargeParticles = true;
			limb.GetComponent<PhysicalBehaviour>().Properties.Conducting = false;
			limb.GetComponent<PhysicalBehaviour>().Temperature = 37f;
	        }
        }

    public class AcidProff : MonoBehaviour
	{
		public LimbBehaviour limb;

        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();

			limb.SkinMaterialHandler.AcidProgress = 0f;
	        }
	    }

	public class RottProff : MonoBehaviour
	{
		public LimbBehaviour limb;

        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();

			limb.SkinMaterialHandler.RottenProgress = 0f;
	        }
	    }

	public class SuperHeart : MonoBehaviour
	{
		public LimbBehaviour limb;

        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();

			limb.CirculationBehaviour.IsPump = true;
	        }
	    }

	public class WakeUp : MonoBehaviour
    {
        public LimbBehaviour limb;
		public bool conscious = true;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
		    }
        protected void Update()
	    {   
			if (limb.Health < limb.InitialHealth * 0.25f)
			{
				conscious = false;
			    }
			else
			{
				conscious = true;
			    }

			if (conscious == true)
			{
			    limb = GetComponent<LimbBehaviour>();
			    limb.Numbness = float.NegativeInfinity;
			    limb.Person.Heartbeat = 60f;
			    limb.Person.BrainDamaged = false;
			    limb.Person.Consciousness = 1f;
			    limb.Person.OxygenLevel = 1f;
				limb.CirculationBehaviour.HealBleeding();
			    }
			else
			{
			    }
	        }
        }

	public class NoFear : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
		    }
        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();
			limb.Person.ShockLevel = 0f;
			limb.Person.PainLevel = 0f;
	        }
        }

	public class SkinStab : MonoBehaviour
    {
        public LimbBehaviour limb;
		public bool Blow = false;
		public bool Active = false;

		public void Start()
		{
			limb = gameObject.GetComponent<LimbBehaviour>();

            foreach (var Limbs in limb.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
			{
			  	Limbs.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");

			    }

			limb.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("EStabbableSkin", (Func<string>) (() => !this.Blow ? "Enable Stabbable Skin" : "Disable Stabbable Skin"), "Toggle Stabbable Skin",
            () =>
            {
				if (Blow == true)
				{
					Active = true;
				    foreach (var Limbs in limb.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
			        {
				        Limbs.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("AndroidArmour");
						Limbs.GetComponent<PhysicalBehaviour>().Properties.SparksOnSlide = false;
	
			            }
				    }
				else
				{
					Active = false;
					foreach (var Limbs in limb.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
			     	{
					    Limbs.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
			  	        }
					}
					
				if (Active == true)
				{
					Blow = false;
				    }
				else
				{
					Blow = true;
					}
			    }));
		    }
	    }

	public class SkinDamageImmunity : MonoBehaviour
    {
        public LimbBehaviour limb;
		public bool Blow = true;
		public bool Active = true;

		public void Start()
		{
			limb = gameObject.GetComponent<LimbBehaviour>();

			limb.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("ESkinDamage", (Func<string>) (() => !this.Blow ? "Disable Skin Damage" : "Enable Skin Damage"), "Toggle Skin Damage",
            () =>
            {
				if (Blow == true)
				{
					Active = true;
				    }
				else
				{
					Active = false;
					}
					
				if (Active == true)
				{
					Blow = false;
				    }
				else
				{
					Blow = true;
					}
			    }));
		    }
        
        public void Update()
	    {
			limb = gameObject.GetComponent<LimbBehaviour>();

			if (Active == true)
            {
				foreach (var Limbs in limb.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
				{
				    Limbs.SkinMaterialHandler.ClearAllDamage();
				    }
			    }
				
			else
			{
			    }
		    }
        }

	public class Undeletable : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
            }
		
		public void Awake()
        {
            CreateContextMenuOptions();
            }

		private void CreateContextMenuOptions()
        {
            var cont = this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;

            cont.Add(new ContextMenuButton("Delete", "Delete", "Delete", () =>
            {
                Destroy(this.GetComponent<PhysicalBehaviour>().transform.root.gameObject);
                }));
            }

        protected void Update()
	    {
			limb.PhysicalBehaviour.Disintegratable = false;
		    limb.PhysicalBehaviour.Deletable = false;
	        }
	    }

	public class Unbreakable : MonoBehaviour
    {
        public LimbBehaviour limb;

        protected void Start()
        {
            limb = GetComponent<LimbBehaviour>();
		    }
        protected void Update()
	    {   
			limb = GetComponent<LimbBehaviour>();
		    limb.HealBone();
			limb.CirculationBehaviour.HealBleeding();
			limb.IsLethalToBreak = false;
			limb.IsDismembered = false;
			limb.PhysicalBehaviour.isDisintegrated = false;
			limb.PhysicalBehaviour.Disintegratable = false;
			limb.gameObject.GetComponent<PhysicalBehaviour>().Disintegratable = false;
			Component[] components = limb.gameObject.GetComponents(typeof(Component));
	        }
        }

	public class AntiFreezeBehaviour : MonoBehaviour
    {
		public void Update()
		{
			if (this.gameObject.GetComponent<FreezeBehaviour>())
            {
                Destroy(this.gameObject.GetComponent<FreezeBehaviour>());
			    }
		    }
        }
    }
// Originally uploaded by 'P a b l 0'. Do not reupload without their explicit permission.
